<?php

namespace Framework\Listeners;

use Framework\Modules\Crm\Adapter as CrmAdapter;
use Framework\Foundation\Config;
use Framework\Modules\DeclineManager;

class HandleSpamCustomer {

    private $event;

    public function handle($event) {

        if(!Config::get('addons.decline-manager.type', 0)) {
            return;
        }

        $this->event = $event;
        $this->crmAdapter = new CrmAdapter(app()->crmInstance());
        if(!$this->crmAdapter->isDecline($this->event->payload['response'])) {
            return;
        }

        $this->declineManager = new DeclineManager;
        $this->declineManager->increementCount();

        if($this->declineManager->resetCounterAfterCardUpdate) {
            $this->declineManager->saveCardData($this->event->payload['request']);
        }
    }
}