<?php

namespace Framework\Middleware;

use Closure;
use Framework\Modules\UserAccess;

class LoadUsersAccessInfo implements \Framework\Contracts\Middleware
{

    /**
     * Handle an incoming request.
     *
     * @param  Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        // Get and add current user token info into config [We need to remove this from here in future]
        if (isset($_COOKIE['access_token']))
        {
            UserAccess::setAccessToken(json_decode($_COOKIE['access_token'], true));
        }
        elseif (isset($_SESSION['access_token']))
        {
            UserAccess::setAccessToken($_SESSION['access_token']);
        }

        return $next($request);
    }

}
