<?php

namespace Framework\Middleware;

use Closure;
use Framework\Foundation\Helper;
use Framework\Models\User;

class MigrateUsersAccessInfo implements \Framework\Contracts\Middleware
{

    /**
     * Handle an incoming request.
     *
     * @param  Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {

        (new User)->createMigration();

        if (!file_exists(STORAGE_PATH.DS.'users.json')) {
            return $next($request);
        }

        $users = Helper::getJsonFileData(STORAGE_PATH, 'users.json');

        if($users->isEmpty()) {
            return $next($request);
        }

        foreach ($users as $user) {
            $userData = [];
            if(!empty($user['user'])) $userData['email'] = $user['user'];
            if(!empty($user['first_name'])) $userData['first_name'] = $user['first_name'];
            if(!empty($user['last_name'])) $userData['last_name'] = $user['last_name'];
            if(!empty($user['pass'])) $userData['password'] = $user['pass'];

            User::firstOrCreate($userData);
        }

        Helper::deleteFileifExists('users.json', STORAGE_PATH);

        return $next($request);
    }

}
