<?php

namespace Framework\Middleware;

use Closure;
use Framework\Foundation\Config;

class SetCrmInstance implements \Framework\Contracts\Middleware {

    public function handle($request, Closure $next)
    {
        $crmType = Config::get('payment_provider.api_type');
        $resolvedClass = $this->resolveCrmClassNamespace($crmType);
        if(!class_exists($resolvedClass)) {
            throw new \Exception(sprintf('Unsupported CRM: %s', $crmType));
        }

        app()->setCrmInstance(new $resolvedClass);

        return $next($request);
    }

    private function resolveCrmClassNamespace($crmType) {
        if($crmType === 'democrm') {
            return '\\'.\Framework\Modules\Crm\Providers\DemoCRM::class;
        }
        
        return sprintf('\Framework\Modules\Crm\Providers\%s', \Illuminate\Support\Str::ucfirst($crmType));
    }
}


