<?php

namespace Framework\Models;

class User extends Model {

    protected function migrations() {

        if($this->tableSchema) return $this->tableSchema;

        $query = sprintf( "CREATE TABLE IF NOT EXISTS %s (", $this->table);
        $query .= "`id` INTEGER PRIMARY KEY /*!40101 AUTO_INCREMENT */, ";
        $query .= "`first_name` varchar(100) DEFAULT NULL, ";
        $query .= "`last_name` varchar(100) DEFAULT NULL, ";
        $query .= "`email` varchar(256) DEFAULT NULL, ";
        $query .= "`password` varchar(256) DEFAULT NULL, ";
        $query .= "`payload` TEXT DEFAULT NULL, ";
        $query .= "`created_at` varchar(20) DEFAULT NULL, ";
        $query .= "`updated_at` varchar(20) DEFAULT NULL);";
        
        // Table alter query from framework version: 4.0.63
        if($this->databseConnection['driver'] === 'sqlite') {
            $query .= sprintf( "ALTER TABLE %s ", $this->table);
            $query .= "ADD `active` TINYINT(1) NOT NULL DEFAULT 1;";
            $query .= sprintf( "ALTER TABLE %s ", $this->table);
            $query .= "ADD `deleted_at` VARCHAR(20) NULL;";
        } else {
            $query .= sprintf( "ALTER TABLE %s ", $this->table);
            $query .= "ADD `active` TINYINT(1) NOT NULL DEFAULT '1' AFTER `payload`, ";
            $query .= "ADD `deleted_at` VARCHAR(20) NULL AFTER `active`;";
        }

        return $query;
    }
}