<?php

namespace Framework\Modules\Crm\Middleware\Checkout;

use Closure;
use Framework\Foundation\Config;

class FilterFormData implements \Framework\Contracts\Middleware {

    public function handle($request, Closure $next)
    {
        $formData = $request->json;

        if (!empty($formData['billingAgreeCheckbox']))
        {
            unset($formData['billingAgreeCheckbox']);
        }

        if (empty($formData['prospectId']))
        {
            return pre_response_array(null, false, ['response_message' => 'Prospect ID can not be empty']);
        }


        if ($formData['billingSameAsShipping'] == 'yes')
        {
            $_SESSION['checkout_billing_data'] = [];

            unset($formData['billingFirstName']);
            unset($formData['billingLastName']);
            unset($formData['billingAddress']);
            unset($formData['billingCity']);
            unset($formData['billingCountry']);
            unset($formData['billingState']);
            unset($formData['billingZip']);
        }
        else
        {
            $_SESSION['checkout_billing_data'] = $formData;

            unset($_SESSION['checkout_billing_data']['prospectId']);
            unset($_SESSION['checkout_billing_data']['billingSameAsShipping']);
            unset($_SESSION['checkout_billing_data']['cc_type']);
            unset($_SESSION['checkout_billing_data']['cc_number']);
            unset($_SESSION['checkout_billing_data']['expmonth']);
            unset($_SESSION['checkout_billing_data']['expyear']);
            unset($_SESSION['checkout_billing_data']['cvv']);
        }

        $request->insureshipCheckbox = 1;

        if (isset($formData['insureshipCheckbox']))
        {
            $request->insureshipCheckbox = $formData['insureshipCheckbox'];
            unset($formData['insureshipCheckbox']);
        }

        if (!empty($_SESSION['prospect_shipping_data']))
        {
            $orderData = array_merge_recursive($_SESSION['prospect_shipping_data'], $formData);
        }
        else
        {
            $orderData = $formData;
        }

        if (Config::get('payment_provider.api_type') != 'response')
        {
            unset($orderData['prospectId']);
        }

        $_SESSION['full_order_data'] = $orderData;

        $request->json = $formData;
        $request->orderData = $orderData;
        return $next($request);
    }
}