<?php

namespace Framework\Modules\Crm\Middleware\Offer;

use Closure;

class FilterFormData implements \Framework\Contracts\Middleware {

    public function handle($request, Closure $next)
    {
        $formData = $request->json;

        if (!empty($formData['agreeCheckbox']))
        {
            unset($formData['agreeCheckbox']);
        }

        $request->insureshipCheckbox = 1;

        if (isset($formData['insureshipCheckbox']))
        {
            $request->insureshipCheckbox = $formData['insureshipCheckbox'];
            unset($formData['insureshipCheckbox']);
        }

        $_SESSION['full_order_data']      = $formData;
        $_SESSION['prospect_shipping_data'] = $formData;

        unset($_SESSION['prospect_shipping_data']['billingSameAsShipping']);
        unset($_SESSION['prospect_shipping_data']['cc_type']);
        unset($_SESSION['prospect_shipping_data']['cc_number']);
        unset($_SESSION['prospect_shipping_data']['expmonth']);
        unset($_SESSION['prospect_shipping_data']['expyear']);
        unset($_SESSION['prospect_shipping_data']['cvv']);

        if ($formData['billingSameAsShipping'] == 'yes')
        {
            $_SESSION['checkout_billing_data'] = [];
            unset($formData['billingFirstName']);
            unset($formData['billingLastName']);
            unset($formData['billingAddress']);
            unset($formData['billingCity']);
            unset($formData['billingCountry']);
            unset($formData['billingState']);
            unset($formData['billingZip']);
        }
        else
        {
            $_SESSION['checkout_billing_data'] = $formData;
            unset($_SESSION['checkout_billing_data']['billingSameAsShipping']);
            unset($_SESSION['checkout_billing_data']['cc_type']);
            unset($_SESSION['checkout_billing_data']['cc_number']);
            unset($_SESSION['checkout_billing_data']['expmonth']);
            unset($_SESSION['checkout_billing_data']['expyear']);
            unset($_SESSION['checkout_billing_data']['cvv']);
        }

        $formData['order_type'] = 'NewOrder';

        $request->json = $formData;
        return $next($request);
    }
}