<?php

namespace Framework\Modules\Crm\Middleware\OrderCancel;

use Closure;
use Framework\Foundation\Config;

class FilterFormData implements \Framework\Contracts\Middleware {

    public function handle($request, Closure $next)
    {
        if (empty(Config::get('addons.easy-cancellation')))
        {
            return pre_response_array(null, false, ['response_message' => 'Order cancellation is disabled for this funnel.']);
        }

        $formData = $request->json;
        if (!array_has($formData, 'orderId') || !array_has($formData, 'email'))
        {
            return pre_response_array(null, false, ['response_message' => 'The request couldn\'t be completed! Required parameters are missing']);
        }

        return $next($request);
    }
}