<?php

namespace Framework\Modules\Crm\Middleware\OrderCancel;

use Closure;
use Framework\Modules\Crm\Adapter as CrmAdapter;

class OrderView implements \Framework\Contracts\Middleware {

    private $crmAdapter;

    public function handle($request, Closure $next)
    {
        $formData = $request->json;
        $this->crmAdapter = new CrmAdapter(app()->crmInstance());;
        
        $request->orderViewResponse = $this->crmAdapter->singleOrderView($formData);
        if (empty($request->orderViewResponse['status']) || ($request->orderViewResponse['status'] != 'success'))
        {
            return pre_response_array(null, false, ['response_message' => $request->orderViewResponse['apiResponse']]);
        }

        if (!$this->crmAdapter->orderBelongsToTheEmail(array_get($request->json, 'email'), $request->orderViewResponse))
        {
            return pre_response_array(null, false, ['response_message' => 'Email id mismatch']);
        }

        return $next($request);
    }
}