<?php

namespace Framework\Modules;

use Framework\Foundation\Config;

class PaayThreeDs
{

    public static function paayVerify()
    {
        // Get paay ThreeDS info
        $paayData = self::getPaayData();

        $config = new \ThreeDS\Integrator\Config($paayData['api_key'], $paayData['api_secret']);
        $config->setDemo(false);
        $config->setTimeout(12);
        if (isset($_POST['threeds_ajax']))
        {
            $config->setReturnResult(true);
        }

        $api             = new \ThreeDS\Integrator\Api\Adapter\Curl($config);
        $payment         = new \ThreeDS\Integrator\Request\PaymentRequest($_POST);
        $responseHandler = new \ThreeDS\Integrator\Response\VerificationResponse();
        $integrator      = new \ThreeDS\Integrator\Integrator($config, $api, $payment, $responseHandler);

        echo $integrator->render();
    }

    private static function getPaayData()
    {
        $appDir   = dirname(dirname(__DIR__));
        $paayFile = $appDir . DIRECTORY_SEPARATOR . 'paay.key';
        if (Config::get('addons.3d_validation.enabled') && file_exists($paayFile))
        {
            $paayDataRaw = file_get_contents($paayFile);
            return json_decode($paayDataRaw, true);
        }
        else
        {
            return ['api_key' => '', 'api_secret' => ''];
        }
    }

    public static function isActivePaay()
    {
        $paayData = PaayThreeDs::getPaayData();
        if (empty($paayData['api_key']) || empty($paayData['api_secret']))
        {
            return false;
        }
        return true;
    }

}
